Package com.xebialabs.deployit.plugin.api.reflect

## Interface IDescriptorRegistry

- All Superinterfaces:
    `java.lang.AutoCloseable`
  All Known Implementing Classes:
    `BaseDescriptorRegistry`

      public interface IDescriptorRegistry
      extends java.lang.AutoCloseable

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `DEFAULT_PRECEDENCE` |
    `static int` | `HIGHEST_PRECEDENCE` |
    `static int` | `LOWEST_PRECEDENCE` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default void` | `close()` |
    `boolean` | `exists​(Type type)` |
    `Descriptor` | `getDescriptor​(Type type)` |
    `java.util.Collection<Descriptor>` | `getDescriptors()` |
    `java.util.List<DescriptorRegistryHook>` | `getHooks()` |
    `DescriptorRegistryId` | `getId()` |
    `default int` | `getOrder()` |
    `java.util.Collection<Type>` | `getSubtypes​(Type supertype)` |
    `boolean` | `isDefault()` |
    `boolean` | `isLocal()` |
    `Type` | `lookupType​(java.lang.Class<?> ciClass)` |
    `Type` | `lookupType​(java.lang.String typeName)` |
    `Type` | `lookupType​(java.lang.String prefix, java.lang.String simpleName)` |
    `void` | `register​(Descriptor descriptor)` |
    `void` | `registerHook​(DescriptorRegistryHook hook)` |
    `void` | `registerSubtype​(Type supertype, Type subtype)` |
    `void` | `verifyTypes()` |

- - ### Field Detail

    - #### HIGHEST_PRECEDENCE

          static final int HIGHEST_PRECEDENCE

      See Also:
        Constant Field Values

    - #### LOWEST_PRECEDENCE

          static final int LOWEST_PRECEDENCE

      See Also:
        Constant Field Values

    - #### DEFAULT_PRECEDENCE

          static final int DEFAULT_PRECEDENCE

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getId

          DescriptorRegistryId getId()

    - #### lookupType

          Type lookupType​(java.lang.String typeName)

    - #### lookupType

          Type lookupType​(java.lang.Class<?> ciClass)

    - #### lookupType

          Type lookupType​(java.lang.String prefix,
                          java.lang.String simpleName)

    - #### isLocal

          boolean isLocal()

    - #### isDefault

          boolean isDefault()

    - #### getOrder

          default int getOrder()

    - #### getDescriptors

          java.util.Collection<Descriptor> getDescriptors()

    - #### exists

          boolean exists​(Type type)

    - #### getDescriptor

          Descriptor getDescriptor​(Type type)

    - #### getSubtypes

          java.util.Collection<Type> getSubtypes​(Type supertype)

    - #### register

          void register​(Descriptor descriptor)

    - #### registerSubtype

          void registerSubtype​(Type supertype,
                               Type subtype)

    - #### verifyTypes

          void verifyTypes()

    - #### close

          default void close()
                      throws java.lang.Exception

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Throws:
        `java.lang.Exception`

    - #### registerHook

          void registerHook​(DescriptorRegistryHook hook)

    - #### getHooks

          java.util.List<DescriptorRegistryHook> getHooks()